
<?php
Titre : Cration dun menu horizontal en cascade

Description : Ce programme permet  un utilisateur, sans connaissance particulire,
 de crer un barre de menu horizontale ou verticale en cascade, non limite en profondeur,  partir dun simple fichier texte.


/*******************************************************************
 *
 * 		Fichier			:	menu_horiz.php3
 * 		Cr le			:	20 avril 2004
 * 		Dernire modif	:	
 * 		Auteur			: 	Mario Culottti
 *		Email			:	m.culotti@free.fr
 * 				 Copyright 2004
 *		
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU General Public License as
 * 	published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *******************************************************************/
/*
Prsentation :
 Ce programme permet  un utilisateur, sans connaissance particulire
 de crer un barre de menu horizontal en cascade.
 Le nombre de menus et sous menus en profondeur nest pas limit. (de 5  des milliers ). 
 Le menu crit par l'utilisateur (menu_horizont.txt), dans un simple traitement de texte,       contient trois champs par ligne :
 		- un niveau de menu (+ pour niveau 1 , ++ pour niveau 2 etc).
		- Un intitul qui apparat  l'affichage
 		- Une adresse web
 		- ex : ++,Aide Rapide,aiderapide.php3

 Ce fichier texte dcrivant le menu va servir  fabriquer le fichier(menu_horiz_fin.txt) correspondant  la traduction de menu_horizont.txt en javascript.
 Ensuite, les fichiers : (menu_horiz_debut.txt (fourni)) et (menu_horiz_fin.txt)
 vont servir  fabriquer le fichier (exmplmenu2_var.js) correspondant au nouveau menu en javascript.
 Il suffit ensuite  pour finir dxcuter menu_horiz.php3  la racine du site o se trouvent les fichiers :        - 
 
 menu_com.js, exmplmenu2_var.js, 
 tridown.gif, trileft.gif, 
 menu_horiz.php3, 
 menu_horizont.txt, menu_horiz_debut.txt, menu_horiz_fin.txt

 Pour crer effectivement le nouveau menu horizontal, il y a quelques lignes  ajouter, une fois pour toute, dans "entete.html" pour appeler le programme javascript qui va crer la barre de menu,  il suffit ensuite  pour finir dxcuter menu_horiz.php3 dans le rpertoire o se trouvent les fichiers cits ci-dessus.
 voir "_rajouter_dans_html.doc"

*/



$tab_ligmenu = array("Menu", "=new Array(\"" , "\",\"" , "\",\"\"," , ");");
$DIM = 19; // dimension max du tableau $t_n 
// $t_n tableau destin  recevoir les indices relatifs aux niveau de menu
// $DIM correspond donc  la profondeur max allant d'un menu racine 
// jusqu' son descendant le plus loign.
$t_n = array(array());
// Initialisation du tableau
for ($i = 0 ; $i <= $DIM ; $i++) {
  for ($j = 0; $j <= $DIM ; $j++) {
  $t_n[$i][$j] = 0;
  }
}

// Initialisation d'une range du tableau t_n
function init_t_n($i) {
global $DIM;
global $t_n;
  for ($j = 0 ; $j <= $DIM ; $j++) {
	$t_n[$i][$j] = 0;
  }
}

// $niv est le niveau de menu relatif  la ligne qu'on examine
// par ex +++ indique un menu de niveau 3 
// fabr_indice sert  fabriquer la chane complte d'un indice donn
// ex : 5_1_4_1 ==> racine 5, sous menu 1, sm 4 dans le sm 1, sm 1 dans le sm 4
function fabr_indice($niv) {
global $DIM;
global $t_n;
$ind_complet = "";
$premier = 0;

// Si $niv est infrieur au niveau max permis on peut travailler
if ($niv <= $DIM) {
  // commencer par effacer tout ce qui ne sert plus
  for ($m = $niv + 1; $m <= $DIM ; $m++) {
    if ($t_n[$m][0] != 0) {
 	  init_t_n($m);
    }
  }  
  // trouver la premire case libre du niveau $niv
  for ($k = 0 ; (($t_n[$niv][$k] != 0 ) and ($k <= $DIM)) ; ) {
	$k++ ;
  }
  // mmoriser l'indice du niveau trait
  if ($k <= $DIM) {
    $t_n[$niv][$k] = $k + 1;  
  }
  // fabriquer l'indice complet de la ligne traite
  for ($m = 1; ($t_n[$m][0] != 0) and ($m <= $DIM) ; $m++) {
  	for ($k = 0 ; (($t_n[$m][$k] != 0 ) and ($k <= $DIM)) ; ) {
		$k++ ;
  	}
	if ($premier == 0) {
	  $underscore = "";
	  $premier = 1;
	}
	else {
	  $underscore = '_';
	}
	if ($k > 1) {
	  $ind_complet = $ind_complet.$underscore.$t_n[$m][$k - 1] ;
	}
	elseif ($t_n[$m][0] != 0) {	
	  $ind_complet = $ind_complet.$underscore.$t_n[$m][0];	
	}
  }
}
return($ind_complet);
}

$menu_utilisateur = fopen("menu_horiz.txt","r");

$lig = 0; // numero de ligne relative  un menu
While (!feof($menu_utilisateur)) {
	$ligne = fgets($menu_utilisateur,1024);
	// suppression des blancs au dbut et  la fin de la line
	$ligne = trim($ligne);
	// extraire le premier caractre
	$sc1 = substr($ligne,0,1);
	// si la chaine commence par un + on la traite sinon rien
	if ($sc1 == '+') {
	$tab_schaine[$lig] = explode(',',$ligne);
	$lg = count($tab_schaine[$lig]);

	if ($lg != 3) {
	  $tab_schaine[$lig][] = "";
	}
	
	//  ici chaque ligne de $tab_schaine contient les 2 ou 3 champs du menu 
	//  relatifs  la ligne traite : 
	// 	$tab_schaine[0] contient le niveau de menu
	// 	$tab_schaine[1] contient l'intitul
	// 	$tab_schaine[2] contient l'adresse
	//  constitution de la nouvelle ligne 
	//
	// il nous manque le numro du menu ( ex 2_2_2 de "Menu2_2_2") et
	// les paramtres de fin de ligne "2,20,138"
	//
	// stocker les indices de lignes trouves dans tab_ind
	$v_niv = strlen($tab_schaine[$lig][0]);
    // $tab_ind[$lig][0] : table des indices de niveau
	// $tab_ind[$lig][1] : table des  niveaux de menu correspondants
	$tab_ind[$lig][0] = fabr_indice($v_niv);
	$tab_ind[$lig][1] = $v_niv;
	if ($v_niv == 1) {
	  $tab_ind[$lig][2] = ",20,138";
	}
	else {
	  $tab_ind[$lig][2] = ",20,150";
	}
	$lig++;
	}
}
fclose($menu_utilisateur);
$menu_h_fin = fopen("menu_horiz_fin.txt" , "w");
// parcourir $tab_ind[$i][1] pour calculer le nombre de sous niveaux
// relatif  un niveau donn
$lig--;
for ($i = 0 ; $i <= $lig ; ) {
  // pour un niveau donn n, on cherche les sous niveaux directs (n+ 1)
  // dont l'indice de dbut est le meme
  // $l_ind : niveau de [], $p_ind : sous chaine de [], 
  // [ l'lment dont on va rechercher les descendants directs ]
  $l_ind = $tab_ind[$i][1]; 
  $l_ind_c = 1 + ($l_ind - 1) * 2;
  $p_ind =  substr($tab_ind[$i][0],0, $l_ind_c );
  $tab_ind[$i][1]  = 0;
  for ($j = $i; $j <= $lig ; ) {
    $cc = $tab_ind[$j][0];
	if (($p_ind == substr($cc ,0,$l_ind_c)) and (strlen($cc) == $l_ind_c + 2)) {
	  $tab_ind[$i][1]++;
	}
  $j++;	
  }

  $string = $tab_ligmenu[0].$tab_ind[$i][0].$tab_ligmenu[1] ;
  $string = $string.$tab_schaine[$i][1].$tab_ligmenu[2].$tab_schaine[$i][2];
  $string = $string.$tab_ligmenu[3].$tab_ind[$i][1].$tab_ind[$i][2];
  $string = $string.$tab_ligmenu[4]."\n";
  $fout = fwrite($menu_h_fin, $string );
  $i++; 
}

fclose($menu_h_fin);

// fabriquer le fichier dfinitif exmplmenu2_var.js avec les fichiers
// menu_horiz_debut.txt et menu_horiz_fin.txt
$menu_h_debut = fopen("menu_horiz_debut.txt" , "r") or die("Impossible d'ouvrir menu_horiz_debut.txt");
$string_debut = fread($menu_h_debut, filesize("menu_horiz_debut.txt"));
fclose($menu_h_debut);

$menu_h_fin = fopen("menu_horiz_fin.txt" , "r") or die("Impossible d'ouvrir menu_horiz_fin.txt");
$string_fin = fread($menu_h_fin, filesize("menu_horiz_fin.txt"));
fclose($menu_h_fin);

$exmplmenu2_var = fopen("exmplmenu2_var.js", "w+");
$string = $string_debut.$string_fin; 
$fout = fwrite($exmplmenu2_var, $string);
fclose($exmplmenu2_var);
echo("<br><br>    <H3>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;*** Le nouveau menu a t correctement cre ***</h3> <br><br>" )
?>
